<template>
  <SearchPanel @onType="typeText" @onClear="clearSearch" />

  <TablePanel :request="request" @click="packageClick" />

  <Footer />

  <Modal v-if="openedModal" :data="modalData" @close="closeModal" />
</template>

<script>
import SearchPanel from "@/components/SearchPanel.vue";
import TablePanel from "@/components/TablePanel.vue";
import Footer from "@/components/Footer.vue";
import Modal from "@/components/Modal.vue";

export default {
  name: "HomeView",
  components: {
    SearchPanel,
    TablePanel,
    Footer,
    Modal,
  },
  data: () => {
    return {
      request: "",
      openedModal: false,
      clearedSearch: false,
      modalData: {
        name: "",
        authorName: "",
        authorEmail: "",
        date: "",
        version: "",
        link: "",
      },
    };
  },
  methods: {
    clearSearch() {
      this.request = "";
    },
    typeText(text) {
      this.request = text;
    },
    closeModal() {
      this.openedModal = false;

      this.modalData = {
        name: "",
        authorName: "",
        authorEmail: "",
        date: "",
        version: "",
        link: "",
      };
    },
    openModal() {
      this.openedModal = true;
    },
    packageClick(data) {
      this.modalData = {
        name: data.name,
        authorName: data.author.name,
        authorEmail: data.author.email,
        date: new Date(data.date).toLocaleDateString(),
        version: data.version,
        link: data.links.npm,
      };

      this.openModal();
    },
  },
};
</script>
